<?
/**
* ajaxDispatcher.php
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

page_open(array('sess' => 'Seminar_Session', 'auth' => 'Seminar_Default_Auth', 'perm' => 'Seminar_Perm', 'user' => 'Seminar_User'));

require_once("classes/myphoto/Photo.class.php");
require_once("classes/myphoto/Album.class.php");
require_once("classes/myphoto/Controller.class.php");

$GLOBALS['perm']->check('autor');

if (!array_key_exists('ajax_cmd', $_REQUEST)) die;

$template_path = dirname(__FILE__).'/templates/html/flexi';
$factory = new Flexi_TemplateFactory($template_path);

switch($_REQUEST['ajax_cmd']) {
	/*case 'showMoreAlbums':
		require_once dirname(__FILE__) . '/MyPhotoPortalPlugin.class.php';
		$portal = new MyPhotoPortalPlugin();
		$portal->setPluginpath('plugins_packages/ZMML/MyPhotoPlugin');
		$portal->mp->public_show_albums_portal();
		break;
	case 'showTagCloud':
		require_once dirname(__FILE__) . '/MyPhotoPortalPlugin.class.php';
		$portal = new MyPhotoPortalPlugin();
		$portal->setPluginpath('plugins_packages/ZMML/MyPhotoPlugin');
		$portal->mp->publicShowTagCloud();
		break;
	case 'showRatedPhotos':
		$t = escapeshellcmd(basename(trim($_REQUEST['t'])));
		$page = escapeshellcmd(basename(trim($_REQUEST['page'])));
		if (!$t || !$page) die;
		require_once dirname(__FILE__) . '/MyPhotoPortalPlugin.class.php';
		$portal = new MyPhotoPortalPlugin();
		$portal->setPluginpath('plugins_packages/ZMML/MyPhotoPlugin');
		$portal->mp->publicShowRatedPhotosPortal($t, $page);
		break;*/
	case 'rate':
		$photo_id = escapeshellcmd(basename(trim($_REQUEST['pid'])));
		$val = escapeshellcmd(basename(trim($_REQUEST['val'])));
		$current_rating = "";
		if ($photo_id && $val && $val < 6 && $val > 0) {
			$p = new Photo();
			$p->load($photo_id);
			$a = new Album();
			$a->load($p->get_album_id());
			if ($a->get_public() == 1) {
				$p->ratePhoto($val, $GLOBALS['auth']->auth['uid']);
			}
			$calc_ratings = $p->calcRatings();
			if ($calc_ratings['anz'] == 0) {
				$current_rating = dgettext('mp',"Noch keine Bewertung vorhanden");
			} else {
				$current_rating = dgettext('mp',"Aktuelle Bewertung") . ": ". $calc_ratings['rating_txt'];
			}
			if (!$p->canRate($GLOBALS['auth']->auth['uid']))
				$current_rating .= "<BR><SPAN STYLE=\"font-size:0.9em; font-weight:bold;}\">".dgettext('mp',"Sie haben bereits bewertet!")."</SPAN>";
			if ($current_rating) echo $current_rating;
		}
		break;
	case 'getRatingStars':
		$photo_id = escapeshellcmd(basename(trim($_REQUEST['pid'])));
		if ($photo_id) {
			$p = new Photo();
			$p->load($photo_id);
			$a = new Album();
			$a->load($p->get_album_id());
			if ($a->get_public() == 1) {
				$calc_ratings = $p->calcRatings();
				$rating_template = $factory->open('rating');
				$rating_template->set_attribute('css_uri', $GLOBALS['ABSOLUTE_URI_STUDIP'].'/plugins_packages/ZMML/MyPhotoPlugin/css');
				$rating_template->set_attribute('uri', $GLOBALS['ABSOLUTE_URI_STUDIP'].'/plugins_packages/ZMML/MyPhotoPlugin');
				$rating_template->set_attribute('p', $p);
				$rating_template->set_attribute('can_rate', $p->canRate($GLOBALS['auth']->auth['uid']));
				$rating_template->set_attribute('current', $calc_ratings['durch']);
				$rating_template->set_attribute('rating_width', $calc_ratings['proz']);
				echo $rating_template->render();
			}
		}
		break;
	case 'tag_completer':
                $val = escapeshellcmd(basename(trim($_REQUEST['value'])));
                if ($val == "") return;
                echo Controller::searchForTags($val);
                break;
	/*case 'searchPhotos':
		$val = escapeshellcmd(basename(trim($_REQUEST['search_text'])));
		$page = escapeshellcmd(basename(trim($_REQUEST['page'])));
		if (!$page) $page = 1;
		if ($val) {
			require_once dirname(__FILE__) . '/MyPhotoPortalPlugin.class.php';
	                $portal = new MyPhotoPortalPlugin();
        	        $portal->setPluginpath('plugins_packages/ZMML/MyPhotoPlugin');
                	echo $portal->mp->publicShowSearchResultsJS($val,$page);
		}
		break; */
	case 'getComments':
		$photo_id = escapeshellcmd(basename(trim($_REQUEST['pid'])));
		if ($photo_id) {
			$p = new Photo();
                        $p->load($photo_id);
                        $a = new Album();
                        $a->load($p->get_album_id());
                        if ($a->get_public() == 1 && $a->get_allow_comments() == 1) {
				require_once dirname(__FILE__) . '/MyPhotoPortalPlugin.class.php';
	                        $portal = new MyPhotoPortalPlugin();
        	                $portal->setPluginpath('plugins_packages/ZMML/MyPhotoPlugin');
                	        $comments = $portal->mp->public_get_comments($p->get_photo_id());
				$out = "";
				foreach ($comments as $c)
					$out .= $c;
				echo $out;
			}
		}
		break;
	default: ;
}
?>
