<?php
/**
* Album.class.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once ("lib/functions.php");

class Album {

	var $user_id;
	var $album_id;
	var $mkdate;
	var $titel;
	var $untertitel;
	var $beschreibung;
	var $public;
	var $start_photo_id;
	var $allow_comments;
	var $range_id;
	var $portal_visible;

	function reset() {
		$this->user_id = "";
		$this->album_id = "";
		$this->mkdate = 0;
		$this->titel = "";
		$this->untertitel = "";
		$this->beschreibung = "";
		$this->public = 0;
		$this->start_photo_id = "";
		$this->allow_comments = 0;
		$this->range_id = "";
		$this->portal_visible = 0;
	}

	function Album() {
		$this->reset();
	}

	function load($album_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT a.* FROM mp_album a WHERE a.album_id='%s'",$album_id);
		if ($db->next_record()) {
	                $this->user_id = $db->f("user_id");
        	        $this->album_id = $db->f("album_id");
                	$this->mkdate = $db->f("mkdate");
	                $this->titel = $db->f("titel");
			$this->untertitel = $db->f("untertitel");
        	        $this->beschreibung = $db->f("beschreibung");
        	        $this->public = $db->f("public");
			$this->start_photo_id = $db->f("start_photo_id");
			$this->allow_comments = $db->f("allow_comments");
			$this->portal_visible = $db->f("portal_visible");
		}
	}

	function save() {
		$db = new DB_Seminar();
		if ($this->album_id == "") {
			$this->album_id = $this->get_new_id();
			$db->queryf("INSERT INTO mp_album (album_id, user_id, titel, untertitel, beschreibung, mkdate, public, allow_comments, portal_visible) VALUES ('%s','%s','%s','%s','%s',%d,%d, %d, %d)",
					$this->album_id,
					$this->user_id,
					$this->titel,
					$this->untertitel,
					$this->beschreibung,
					$this->mkdate,
					$this->public,
					$this->allow_comments,
					$this->portal_visible
					);
		} else {
			$db->queryf("UPDATE mp_album SET titel='%s', untertitel='%s', beschreibung='%s', public=%d, start_photo_id='%s', allow_comments=%d, portal_visible=%d WHERE album_id='%s' AND user_id='%s'",
					$this->titel,
					$this->untertitel,
					$this->beschreibung,
					$this->public,
					$this->start_photo_id,
					$this->allow_comments,
					$this->portal_visible,
					$this->album_id,
					$this->user_id);

		}
	}

	function delete() {
		if ($this->album_id != "") {
			$db = new DB_Seminar();
			$db->queryf("DELETE FROM mp_range WHERE album_id='%s'",$this->album_id);
			$db->queryf("DELETE FROM mp_album WHERE album_id='%s' AND user_id='%s'",$this->album_id,$this->user_id);
			$db->queryf("SELECT * FROM mp_photo WHERE album_id='%s' AND user_id='%s'",$this->album_id,$this->user_id);
			while ($db->next_record()) {
				$p = new Photo();
				$p->load($db->f("photo_id"));
				$p->delete();
			}
			$this->reset();
		}
	}

	function update_sort($album_id, $sort, $range_id) {
                if ($album_id != "") {
                        $db = new DB_Seminar();
	                $db->queryf("UPDATE mp_range SET sort=%d WHERE album_id='%s' AND range_id='%s'", $sort, $album_id, $range_id);
                }
        }

	function get_next_photo_id($album_id, $photo_id) {
		$next_id = "";
		$prev_id = "";
		if ($album_id != "" && $photo_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT * FROM mp_photo WHERE album_id='%s' ORDER BY sort ASC", $album_id);
			while ($db->next_record()) {
				if ($prev_id == $photo_id) {
					$next_id = $db->f("photo_id");
					break;
				}
				if ($db->f("photo_id") == $photo_id) 
					$prev_id = $db->f("photo_id");
			}
		}
		return $next_id;
	}

	function add_range($range_id, $edit_mode="") {
		if ($this->album_id != "" && $range_id != "") {
			$db = new DB_Seminar();
			$db->queryf("INSERT INTO mp_range (range_id, album_id, edit_mode) VALUES ('%s', '%s', '%s')",$range_id, $this->album_id, $edit_mode);
		}
	}

	function remove_range($range_id) {
		if ($this->album_id != "" && $range_id != "") {
			$db = new DB_Seminar();
			$db->queryf("DELETE FROM mp_range WHERE range_id='%s' AND album_id='%s'",$range_id, $this->album_id);
		}
	}

	function is_in_range($range_id) {
		if ($range_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT * FROM mp_range WHERE album_id='%s' AND range_id='%s'",$this->album_id, $range_id);
			if ($db->next_record())
				return TRUE;
		}
		return FALSE;
	}

	function get_current_ranges() {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT range_id FROM mp_range WHERE album_id='%s'",$this->album_id);
		while ($db->next_record()) {
			array_push($ret, $db->f("range_id"));
		}
		return $ret;
	}

	function get_edit_mode($range_id) {
		if ($range_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT edit_mode FROM mp_range WHERE album_id='%s' AND range_id='%s'",$this->album_id,$range_id);
			if ($db->next_record())
				return $db->f("edit_mode");
		}
		return "";
	}

	function set_edit_mode($range_id, $edit_mode) {
		if ($range_id != "" && $edit_mode != "" && !(array_search($edit_mode, array('d'=>'dozent','t'=>'tutor','a'=>'autor')) === FALSE)) {
			$db = new DB_Seminar();
			$db->queryf("UPDATE mp_range SET edit_mode='%s' WHERE range_id='%s' AND album_id='%s'",$edit_mode,$range_id,$this->album_id);
		}
	}

	function get_prev_photo_id($album_id, $photo_id) {
		$next_id = "";
		$prev_id = "";
		if ($album_id != "" && $photo_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT * FROM mp_photo WHERE album_id='%s' ORDER BY sort ASC", $album_id);
			while ($db->next_record()) {
				if ($db->f("photo_id") == $photo_id)
					break;
				$prev_id = $db->f("photo_id");
			}
		}
		return $prev_id;
	}

	function get_untertitel() {
		return $this->untertitel;
	}

	function get_user_id() {
		return $this->user_id;
	}

	function get_album_id() {
		return $this->album_id;
	}

	function get_mkdate() {
		return $this->mkdate;
	}

	function get_titel() {
		return $this->titel;
	}

	function get_beschreibung() {
		return $this->beschreibung;
	}

	function get_public() {
		return $this->public;
	}

	function get_start_photo_id() {
		return $this->start_photo_id;
	}

	function get_allow_comments() {
		return $this->allow_comments;
	}

	function get_portal_visible() {
		return $this->portal_visible;
	}


	function set_untertitel($t) {
		$this->untertitel = $t;
	}

	function set_user_id($id) {
		$this->user_id = $id;
	}

	function set_album_id($id) {
		$this->album_id = $id;
	}

	function set_titel($t) {
		$this->titel = $t;
	}

	function set_beschreibung($b) {
		$this->beschreibung = $b;
	}

	function set_public($b) {
		$this->public = $b;
	}

	function set_mkdate($b) {
		$this->mkdate = $b;
	}

	function set_start_photo_id($s) {
		$this->start_photo_id = $s;
	}

	function set_allow_comments($s) {
		$this->allow_comments = $s;
	}

	function set_portal_visible($s) {
		$this->portal_visible = $s;
	}

        function get_new_id() {
                return md5(uniqid(time()));
        }

}

?>
