<?php
/**
* Photo.class.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


require_once ("lib/functions.php");

class Photo {

	var $photo_id;
	var $user_id;
	var $album_id;
	var $mkdate;
	var $titel;
	var $beschreibung;
	var $file_id;
	var $ext;
	var $sort;
	var $license;

	function reset() {
		$this->photo_id = "";
		$this->user_id = "";
		$this->album_id = "";
		$this->mkdate = 0;
		$this->titel = "";
		$this->beschreibung = "";
		$this->file_id = "";
		$this->ext = "";
		$this->sort = 0;
		$this->license = "";
	}

	function Photo() {
		$this->reset();
	}

	function load($photo_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM mp_photo WHERE photo_id='%s'",$photo_id);
		if ($db->next_record()) {
			$this->photo_id = $db->f("photo_id");
	                $this->user_id = $db->f("user_id");
        	        $this->album_id = $db->f("album_id");
                	$this->mkdate = $db->f("mkdate");
	                $this->titel = $db->f("titel");
        	        $this->beschreibung = $db->f("beschreibung");
			$this->file_id = $db->f("file_id");
			$this->ext = $db->f("ext");
			$this->sort = $db->f("sort");
			$this->license = $db->f("license");
		}
	}

	function save() {
		$db = new DB_Seminar();
		if ($this->photo_id == "") {
			$this->photo_id = $this->get_new_id();
			$db->queryf("INSERT INTO mp_photo (photo_id, user_id, album_id, mkdate, titel, beschreibung, file_id, ext, sort, license) VALUES ('%s','%s','%s',%d,'%s','%s','%s','%s',%d,'%s')",
					$this->photo_id,
					$this->user_id,
					$this->album_id,
					$this->mkdate,
					$this->titel,
					$this->beschreibung,
					$this->file_id,
					$this->ext,
					$this->sort,
					$this->license);
		} else {
			$db->queryf("UPDATE mp_photo SET titel='%s', beschreibung='%s', sort=%d, album_id='%s', license='%s'  WHERE photo_id='%s' AND user_id='%s'",
					$this->titel,
					$this->beschreibung,
					$this->sort,
					$this->album_id,
					$this->license,
					$this->photo_id,
					$this->user_id);
		}
	}

	function delete() {
		if ($this->photo_id != "") {
			$db = new DB_Seminar();
			$db->queryf("DELETE FROM mp_photo WHERE photo_id='%s' AND user_id='%s'",$this->photo_id,$this->user_id);
			$db->queryf("DELETE FROM mp_photo_comment WHERE photo_id='%s'",$this->photo_id);
			$db->queryf("DELETE FROM mp_file_content WHERE file_id='%s'",$this->file_id);
			$this->reset();
		}
	}

	function update_sort($photo_id, $sort) {
		if ($photo_id != "") {
			$db = new DB_Seminar();
			$db->queryf("UPDATE mp_photo SET sort=%d WHERE photo_id='%s'", $sort, $photo_id);
		}
	}

	function calcRatings() {
		$ret = array('sum'=>0, 'anz'=>0, 'proz'=>0, 'durch'=>0);
		$db = new DB_Seminar();
		$db->queryf("SELECT rate FROM mp_ratings WHERE photo_id='%s'",$this->photo_id);
		while ($db->next_record())
			$ret['sum'] += $db->f('rate');
		$ret['anz'] = $db->num_rows();
		if ($ret['sum'] && $ret['anz']) {
			$ret['durch'] = round($ret['sum'] / $ret['anz'], 1);
			$ret['rating_txt'] = $ret['durch'].' / 5';
		}
		if ($ret['durch']) $ret['proz'] = floor($ret['durch'] * 100 / 5);
		return $ret;
	}

	function ratePhoto($val, $user_id) {
                if ($this->canRate($user_id)) {
                	$db = new DB_Seminar();
                        $id = md5(uniqid(time().$this->photo_id.$user_id));
                        $db->queryf("INSERT INTO mp_ratings (rate_id, photo_id, user_id, rate) VALUES ('%s','%s','%s',%d)",$id, $this->photo_id, $user_id, $val);
                }
        }

	function canRate($user_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM mp_ratings WHERE photo_id='%s' AND user_id='%s'",$this->photo_id, $user_id);
                if (!$db->next_record())
			return TRUE;
		else
			return FALSE;
	}

	function get_photo_id() {
		return $this->photo_id;
	}

	function get_user_id() {
		return $this->user_id;
	}

	function get_album_id() {
		return $this->album_id;
	}

	function get_mkdate() {
		return $this->mkdate;
	}

	function get_titel() {
		return $this->titel;
	}

	function get_beschreibung() {
		return $this->beschreibung;
	}

	function get_file_id() {
		return $this->file_id;
	}

	function get_ext() {
		return $this->ext;
	}

	function get_sort() {
		return $this->sort;
	}

	function get_license() {
		return $this->license;
	}

	function get_file_content() {
		if ($this->file_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT file_content FROM mp_file_content WHERE file_id='%s'",$this->file_id);
			if ($db->next_record())
				return $db->f("file_content");
		}
		return null;
	}

	function get_file_content_thumb() {
		if ($this->file_id != "") {
			$db = new DB_Seminar();
			$db->queryf("SELECT file_content_thumb FROM mp_file_content WHERE file_id='%s'",$this->file_id);
			if ($db->next_record())
				return $db->f("file_content_thumb");
		}
		return null;
	}

	function set_file_id($f) {
		$this->file_id = $f;
	}

	function set_photo_id($id) {
		$this->photo_id = $id;
	}

	function set_user_id($id) {
		$this->user_id = $id;
	}

	function set_album_id($id) {
		$this->album_id = $id;
	}

	function set_titel($t) {
		$this->titel = $t;
	}

	function set_beschreibung($b) {
		$this->beschreibung = $b;
	}

	function set_mkdate($d) {
		$this->mkdate = $d;
	}

	function set_ext($e) {
		$this->ext = $e;
	}

	function set_sort($s) {
		$this->sort = $s;
	}

	function set_license($s) {
		$this->license = $s;
	}

	function set_file_content($c,$thumb, $update=FALSE) {
		if ($c != "" && $thumb != "" && $this->file_id != "") {
			$db = new DB_Seminar();
			if ($update)
				$db->queryf("UPDATE mp_file_content SET file_content='%s', file_content_thumb='%s' WHERE file_id='%s'", $c, $thumb, $this->file_id);
			else
				$db->queryf("INSERT INTO mp_file_content (file_id, file_content, file_content_thumb) VALUES ('%s','%s','%s')",$this->file_id, $c, $thumb);
		}
	}

	function setTags($t) {
                $db = new DB_Seminar();
                $db2 = new DB_Seminar();
                if (trim($t) == "") return;
                $tags = explode(',',$t);
                $current_tags = $this->getTags();
                foreach ($tags as $t) {
                        $t = trim(strtolower($t));
                        if ($t == "") continue;
                        if (in_array($t, $current_tags)) continue;
                        $db->queryf("SELECT * FROM mp_tags WHERE tag='%s'",$t);
                        if ($db->next_record()) {
                                $db2->queryf("INSERT INTO mp_tag_photo (photo_id, tag_id, mkdate) VALUES ('%s','%s', UNIX_TIMESTAMP())", $this->photo_id, $db->f('tag_id'));
                        } else {
                                $id = md5(uniqid(time().$this->photo_id));
                                $db2->queryf("INSERT INTO mp_tags (tag_id, tag) VALUES ('%s','%s')", $id, $t);
                                $db2->queryf("INSERT INTO mp_tag_photo (photo_id, tag_id, mkdate) VALUES ('%s','%s', UNIX_TIMESTAMP())", $this->photo_id, $id);
                        }
                        array_push($current_tags, $t);
                }
        }

	function getTags() {
                $ret = array();
                $db = new DB_Seminar();
                $db->queryf("SELECT tag FROM mp_tags t, mp_tag_photo ta WHERE ta.photo_id='%s' AND t.tag_id=ta.tag_id", $this->photo_id);
                while ($db->next_record())
                        array_push($ret, $db->f('tag'));
                return $ret;
        }

        function removeTag($tag) {
                if (!$this->photo_id || !$tag) return;
                $db = new DB_Seminar();
                $db2 = new DB_Seminar();
                $db->queryf("SELECT ta.* FROM mp_tag_photo ta, mp_tags t WHERE t.tag='%s' AND ta.tag_id=t.tag_id",$tag);
                $anz = $db->num_rows();
                $db->next_record();
                $db2->queryf("DELETE FROM mp_tag_photo WHERE tag_id='%s' AND photo_id='%s'",$db->f('tag_id'),$this->photo_id);
                if ($anz == 1)
                        $db2->queryf("DELETE FROM mp_tags WHERE tag_id='%s' AND owner!='root'",$db->f('tag_id'));
        }


	// Generiert eine eindeutige ID.
        // return: string (id)
        function get_new_id() {
                return md5(uniqid(time()));
        }
}

?>
