<?php
/**
* SlideShowHandler.class.php
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once "Album.class.php";
require_once "Controller.class.php";

class SlideShowHandler {
	var $a_id;
	var $a;
	var $c;
	var $plugin_path;

	function SlideShowHandler(){
		$this->a_id = "";
		$this->a = null;
		$this->c = new Controller();
		$this->plugin_path = "";
	}

	function set_plugin_path($s) {
		$this->plugin_path = $s;
	}

	function set_album_id($s) {
		if (trim($s) != "") {
			$this->a_id = trim($s);
			$this->a = new Album();
			$this->a->load($this->a_id);
		}
	}

	function show_content() {

		$assets = $GLOBALS['ASSETS_URL']."/images";
		$album_id = $this->a_id;
		$path = $this->plugin_path;
		$first_id = $this->c->get_first_photo_id($this->a_id);

		$slides = "";
		$imgs = "";
                $photos = $this->c->get_all_photos_in_album($album_id);
                if (count($photos) > 0) {
                        $ind = 0;
                        foreach ($photos as $p) {
				if ($p->get_photo_id() != $first_id)
					$slides .= "<a href=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."/$path/download.php?photo_id=".$p->get_photo_id()."&t=.".$p->get_ext()."\" rel=\"lyteshow[slides]\" TITLE=\"".htmlReady($p->get_titel())."\"></a>\n";
                                $ind++;
                        }
                }
		echo "\n<DIV STYLE=\"display:none;\">$slides</DIV>\n";
	}

	function get_next_image_id($prev_id) {
		echo $this->a->get_next_photo_id($this->a_id, $prev_id);
	}

	function get_image() {
		return "<IMG ID=\"slideshow_img\" SRC=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."/plugins_packages/ZMML/MyPhotoPlugin/download.php?photo_id=".$this->c->get_first_photo_id($this->a_id)."&t=.jpg\" BORDER=\"0\"\" />";
	}
}
?>
