<?php
/**
* update_sort.class.php
*
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


page_open(array("sess" => "Seminar_Session", "auth" => "Seminar_Default_Auth", "perm" => "Seminar_Perm", "user" => "Seminar_User"));
$GLOBALS['perm']->check('autor');

require_once("classes/myphoto/Photo.class.php");
require_once("classes/myphoto/Album.class.php");

if (isset($_REQUEST['sortierung']) && isset($_REQUEST['range_id'])) {

	$range_id = escapeshellcmd(basename(trim($_REQUEST['range_id'])));

	if (isset($_REQUEST['album_id'])) { // Photos sortieren
	        $album_id = escapeshellcmd(basename(trim($_REQUEST['album_id'])));
		$a = new Album();
		$a->load($album_id);

		if (!$a->is_in_range($range_id)) {
			echo "Not in range!";
			die;
		}

        	if (!($a->get_user_id() == $GLOBALS['auth']->auth['uid'] || 
		      $GLOBALS['perm']->have_perm("root") || 
                      $GLOBALS['perm']->have_studip_perm($a->get_edit_mode($range_id),$range_id))) {
			echo "No permission!";
			die;
		}

		$sortierung = explode("photos[]=", preg_replace(array("/\&/"),array(""),$_REQUEST['sortierung']));

		foreach ($sortierung as $s) {
			if ($s=="") continue;
			$p = new Photo();
			$p->load($s);
			if (!$p->get_album_id() == $album_id) {
				echo "Wrong album!";
				die;
			}
		}
	
		$count = 0;
	        foreach ($sortierung as $sort) {
        		if (trim($sort) != "") {
       	        		Photo::update_sort($sort, $count);
                        	$count++;
	                }
        	}

	} else { // Alben sortieren

		$sortierung = explode("alben[]=", preg_replace(array("/\&/"),array(""),$_REQUEST['sortierung']));

		foreach ($sortierung as $s) {
			if ($s=="") continue;
			$a = new Album();
			$a->load($s);
			if (!$a->is_in_range($range_id)) {
				echo "Not in range!";
				die;
			}
			if (!($a->get_user_id() == $GLOBALS['auth']->auth['uid'] || 
			      $GLOBALS['perm']->have_perm("root") || 
			      $GLOBALS['perm']->have_studip_perm($a->get_edit_mode($range_id),$range_id))) {
				echo "No permission!";
				die;
			}
		}

		$count = 0;
        	foreach ($sortierung as $sort) {
        		if (trim($sort) != "") {
	       	        	Album::update_sort($sort, $count, $_REQUEST['range_id']);
        	                $count++;
                	}
	        }
	}
}
// Save data back to database.
page_close();

?>
